//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSilver
#property indicator_color4  clrSilver
#property indicator_color5  clrDeepSkyBlue
#property indicator_color6  clrSandyBrown
#property indicator_color7  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property strict

//
//
//
//
//

extern int                period     = 14;          // Calculating period
extern ENUM_APPLIED_PRICE price      = PRICE_CLOSE; // Price
extern int                aperiod    = 14;          // Average period
extern ENUM_MA_METHOD     amethod    = MODE_EMA;    // Average method

double bufferu[];
double bufferuh[];
double bufferd[];
double bufferdh[];
double buffera[];
double bufferada[];
double bufferadb[];
double trend[];
double prices[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,bufferuh ,INDICATOR_DATA); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferdh ,INDICATOR_DATA); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferu  ,INDICATOR_DATA);
   SetIndexBuffer(3,bufferd  ,INDICATOR_DATA);
   SetIndexBuffer(4,buffera  ,INDICATOR_DATA);
   SetIndexBuffer(5,bufferada,INDICATOR_DATA);
   SetIndexBuffer(6,bufferadb,INDICATOR_DATA);
   SetIndexBuffer(7,trend    ,INDICATOR_CALCULATIONS);
   SetIndexBuffer(8,prices   ,INDICATOR_CALCULATIONS);
   IndicatorShortName("momentum trend ("+(string)period+","+(string)aperiod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,bufferada,bufferadb);
   for(int i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,aperiod,0,amethod,price,i);
      double avgUp=0,avgDn=0,up=0,dn=0;
         for(int k=0; k<period && (i+k+1)<Bars; k++)
         {
            double diff = prices[i+k]- prices[i+k+1];
            if(diff>0) { avgUp += diff; up++; }
            if(diff<0) { avgDn -= diff; dn++; }
         }
         if (up!=0) avgUp /= up;
         if (dn!=0) avgDn /= dn;
         
         //
         //
         //
         //
         //
         
         bufferuh[i]  = EMPTY_VALUE;
         bufferdh[i]  = EMPTY_VALUE;
         bufferada[i] = EMPTY_VALUE;
         bufferadb[i] = EMPTY_VALUE;
         bufferd[i]   = -avgDn;
         bufferu[i]   =  avgUp;
         if (i<Bars-1)
         {
            trend[i] = trend[i+1];
               if (avgUp>MathAbs(avgDn)) trend[i] =  1;
               if (avgUp<MathAbs(avgDn)) trend[i] = -1;
               if (trend[i]== 1) { bufferuh[i] =  avgUp; buffera[i] =  avgUp;                                           }
               if (trend[i]==-1) { bufferdh[i] = -avgDn; buffera[i] = -avgDn; PlotPoint(i,bufferada,bufferadb,buffera); }
         }         
   
   }      
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}